DECLARE SUB DoMeteor ()
DECLARE SUB InitImageData (FileName$, ImageArray%())
DECLARE SUB MakeImageIndex (ImageArray%(), IndexArray%())
DECLARE SUB DoEnding ()
DECLARE SUB Rel.CopyPage (DestBuffer%(), SrcBuffer%())
DECLARE SUB Rel.SetActivePage (VideoBuf%())
DECLARE SUB DoSprites ()
DECLARE SUB DoPal ()
DECLARE SUB Rel.FadeToPalX (StartCol%, EndCol%, PalString$, Counts%)
DECLARE SUB Rel.FadeX (StartCol%, EndCol%, R%, G%, B%, Counts%)
DECLARE SUB Rel.NegativePal ()
DECLARE SUB Rel.RotatePalB (StartCol%, EndCol%)
DECLARE SUB Rel.RotatePalF (StartCol%, EndCol%)
DECLARE SUB Rel.SwitchToPal (PalString$)
DECLARE SUB Init ()
DECLARE SUB DoGFX ()
DECLARE SUB Rel.LoadPal (File$, PalString$, Switch%)
DECLARE SUB Rel.Box (VideoBuf%(), X1%, Y1%, X2%, Y2%, Clr%)
DECLARE SUB Rel.BoxT (VideoBuf%(), X1%, Y1%, X2%, Y2%, Clr%)
DECLARE SUB Rel.Ellipse (VideoBuf%(), Xcenter%, Ycenter%, Xrad%, Yrad%, Clr%)
DECLARE SUB Rel.EllipseF (VideoBuf%(), Xcenter%, Ycenter%, Xrad%, Yrad%, Clr%)
DECLARE SUB Rel.EllipseFT (VideoBuf%(), Xcenter%, Ycenter%, Xrad%, Yrad%, Clr%)
DECLARE SUB Rel.EllipseT (VideoBuf%(), Xcenter%, Ycenter%, Xrad%, Yrad%, Clr%)
DECLARE SUB Rel.Fade (R%, G%, B%, Counts%)
DECLARE SUB Rel.FadeToPal (PalString$, Counts%)
DECLARE SUB Rel.Get (VideoBuf%(), X1%, Y1%, X2%, Y2%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.KgenFont (VideoBuf%(), X%, Y%, Font$, MinColor%, Italic%)
DECLARE SUB Rel.LoadPalPP256 (File$)
DECLARE SUB Rel.PageClear (VideoBuf() AS INTEGER)
DECLARE SUB Rel.PageCls (VideoBuf%(), Clr%)
DECLARE SUB Rel.PageVideoCopy (X%, Y%, VideoBuf%(), Action%)
DECLARE SUB Rel.Pset (VideoBuf%(), X%, Y%, Clr%)
DECLARE SUB Rel.SpriteC (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%, Clr%)
DECLARE SUB Rel.SpriteCT (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%, Clr%)
DECLARE SUB Rel.SpriteG (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%, GammaVal%)
DECLARE SUB Rel.SpriteT (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.PageInit (VideoBuf%(), Xmax%, Ymax%)
DECLARE FUNCTION Rel.Point% (VideoBuf%(), X%, Y%)
DECLARE FUNCTION Rel.Collide% (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE FUNCTION Rel.FastKB% ()
DECLARE SUB Rel.Sprite (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE FUNCTION Rel.Size% (X1%, Y1%, X2%, Y2%)
DECLARE SUB Rel.LineT (VideoBuf%(), X%, Y%, X2%, Y2%, Clr%)
DECLARE SUB Rel.Line (VideoBuf%(), X%, Y%, X2%, Y2%, Clr%)
DECLARE SUB Rel.ReadPal (PalString$)
DECLARE SUB Rel.ReadRGB (ColorVal%, R%, G%, B%)
DECLARE SUB Rel.WriteRGB (ColorNum%, R%, G%, B%)

'/==================PURE QB CODE 13H PAGE DOUBLE BUFFERING===================
'FAST ENOUGH FOR MOST PURPOSES.....
'I made this Routines except pp256 Routines by Chris Chadwick
'This Demo is a pure QB code example of screen 13 page emulation
'I took the initiative to make this for 2 reasons....
'1. A post from QB45.Com's forum and
'2. I'm planning a to make an RPG and/or Tutorial using this Routines.
'3. Demand from Purists to make a fast enough flickerless pureQB games.

'Author: RICHARD ERIC M. LOPE aka Relsoft(Philippines)
'Degree: Bachelor of Science in Nursing
'Email:  vic_viperph@yahoo.com
'Site: Http//Auraflow.Curvehead.com

'/======Disclaimer=============
'The Author is in no way liable for any damage done to your computer.
'Use/Abuse the code/Routines freely(though would like it if I'm credited...hehehehe)

'/===========================================================================
'/===========VERY IMPORTANT INITIALIZATION!!!!===============================
'/===========ALL YOUR PROGS SHOULD HAVE THIS!!!!=============================
'/===========================================================================
DEFINT A-Z              'my first command on all my progs(speed)
TYPE ScreenType
        Xmax    AS INTEGER
        Ymax    AS INTEGER
END TYPE

'========Declare constants here
CONST FALSE = 0, TRUE = NOT FALSE
'KeyBoard
CONST KEYRIGHT = 77, KEYLEFT = 75, KEYDOWN = 80, KEYUP = 72
CONST KEYESC = 1, KEYENTER = 28, KEYSPACE = 57, KEYTAB = &HF

REM $STATIC
'This  Array is very important as they are here to speed things up.
DIM SHARED YsegLUT(199) AS LONG
DIM SHARED Scr AS ScreenType
'/===========================================================================
'/==============END INITIALIZATION ROUTINES==================================
'/===========================================================================
'/===========================================================================
REM $DYNAMIC
'ADD YOUR CODE HERE.........
'/====Start of code=======
TYPE SpriteType
        X       AS INTEGER
        Y       AS INTEGER
        XV      AS INTEGER
        YV      AS INTEGER
        id      AS INTEGER
        PutMode AS INTEGER
        Gamma   AS INTEGER
END TYPE

TYPE Startype
        X       AS INTEGER
        Y       AS INTEGER
        R       AS INTEGER
        A       AS INTEGER
        S       AS SINGLE
        C       AS INTEGER
END TYPE

CONST X1max = 319, Y1max = 199

REDIM SHARED Vpage(1) AS INTEGER        'first page
REDIM SHARED Vpage2(1) AS INTEGER       'Bg page used in DoSprites sub

DIM SHARED RGBpal AS STRING * 768
DIM SHARED Path$

CLS
SCREEN 13

RANDOMIZE TIMER
Init
DoGFX
DoPal
DoSprites
DoMeteor
DoEnding

'/====End of code=========
END

ImageData: 'METEOR.PUT image data. Made by PP256
DATA 80
DATA 48,6,0,-29809,0,-28928,-29809,139,-28785,-29299,-30070,-29813,-29299,-30070,-30208,-30070,138,0,-30070,0
DATA 48,6,0,0,0,0,-29556,0,-29696,-29042,137,-29696,-30322,137,0,-30327,0,0,0,0
DATA 48,6,0,0,0,0,0,0,0,-30208,0,0,138,0,0,0,0,0,0,0
DATA 48,6,0,0,0,0,0,0,0,136,0,0,-30720,0,0,0,0,0,0,0

REM $STATIC
SUB DoEnding STATIC

REDIM Test$(36)


Test$(0) = "                <<CREDITS>>"
Test$(1) = "Auraflow<http://Auraflow.Curvehead.Com>"
Test$(2) = "Members:"
Test$(3) = "   Eero Pitkanen(eebro/ebr)"
Test$(4) = "   Adigun A. Polack"
Test$(5) = "   Achmad Aulia(L_O_J)"
Test$(6) = "   Bobby Leigh(Beta_SS)"
Test$(7) = "   Richard Eric M. Lope BSN,RN(relsoft)"
Test$(8) = "   Anya Therese Lope"
Test$(9) = "Greets to:"
Test$(10) = "       WildCard"
Test$(11) = "       Jason Earl"
Test$(12) = "       CGI Joe"
Test$(13) = "       Glenn"
Test$(14) = "       Piptol"
Test$(15) = "       WisdomDude"
Test$(16) = "       Giancarlo"
Test$(17) = "       Lachie Dazdarian"
Test$(18) = "       Kack"
Test$(19) = "       Toshi Horie"
Test$(20) = "       Joakim AR"
Test$(21) = "       Flingmaster"
Test$(22) = "       Bobby 3999"
Test$(23) = "       Xchaser"
Test$(24) = "       JtM"
Test$(25) = "       Jocke the Beast"
Test$(26) = "       Mr. Moose"
Test$(27) = "       Nory B"
Test$(28) = "       Jake"
Test$(29) = "       ChaoTic"
Test$(30) = "       DarkDread"
Test$(31) = "       Andrew Ayers"
Test$(32) = "       Robert Lee"
Test$(33) = "       Brett Phillips"
Test$(34) = "       Engr. Marino Osorio"
Test$(35) = "       Nathan Asshanti"
Test$(36) = "Happy Coding!!! :*)"

FOR I = 199 TO -16 * UBOUND(Test$) STEP -1
        Rel.PageClear Vpage()
                FOR J = 0 TO UBOUND(Test$)
                Rel.KgenFont Vpage(), 0, I + (J * 16), Test$(J), 23, TRUE
                NEXT J
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
        Rel.PageVideoCopy 0, 0, Vpage(), 1
        IF INKEY$ <> "" THEN EXIT FOR
NEXT I
ERASE Test$

END SUB

SUB DoGFX

ScrnXmax = 319
ScrnYmax = 199
Px1 = 0
Py1 = 0

Rel.PageInit Vpage(), ScrnXmax, ScrnYmax
Rel.LoadPal Path$ + "Relpal.Pal", RGBpal, TRUE
Rel.Fade 0, 0, 0, 0

Rel.PageClear Vpage()
'Get Sprites


Size = Rel.Size(0, 0, 15, 15)
DIM Array(Size) AS INTEGER
C = 185
FOR X = 0 TO 15
        C = C + 1
        Rel.Box Vpage(), 100 + X, 100 + X, 115 - X, 115 - X, C
NEXT X
Rel.Get Vpage(), 100, 100, 115, 115, Array(), 0
Rel.Box Vpage(), 100, 100, 115, 115, 15
Rel.Sprite Vpage(), 0, 0, Array(), 0
Rel.PageVideoCopy Px1, Py1, Vpage(), 1


Rel.PageClear Vpage()
Size = Rel.Size(20, 30, 80, 70)
DIM Array2(Size) AS INTEGER
C = 175
Xc = 50
Yc = 50
FOR X = 0 TO 15
        C = C + 1
        Rel.EllipseF Vpage(), Xc, Yc, 32 - X, 20 - X, C
NEXT X
Rel.EllipseF Vpage(), Xc, Yc, 10, 5, 0
Rel.Get Vpage(), 20, 30, 80, 70, Array2(), 0

Rel.PageCls Vpage(), 45
Rel.PageVideoCopy 0, 0, Vpage(), 1
Rel.FadeToPal RGBpal, 100

DO
Rel.Box Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.Pset Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.Line Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.EllipseF Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.Ellipse Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.KgenFont Vpage(), 0, 180, "Normal Full Screen Drawing Primitives", 70, FALSE
Rel.KgenFont Vpage(), 0, 190, "Clipping Supported!!!!", 70, FALSE
Rel.PageVideoCopy Px1, Py1, Vpage(), 1
LOOP UNTIL INKEY$ <> ""
Rel.PageCls Vpage(), 155


DO
Rel.Sprite Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0
Rel.SpriteCT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 150
Rel.SpriteT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0
Rel.SpriteC Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 100
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, -6
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 6

Rel.Sprite Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0
Rel.SpriteCT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 150
Rel.SpriteT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0
Rel.SpriteC Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 100
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, -6
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 6

Rel.KgenFont Vpage(), 0, 180, "Sprites(Normal,Gamma,Color,& Translucent.", 70, FALSE
Rel.KgenFont Vpage(), 0, 190, "Clipping Supported!!!!", 70, FALSE
Rel.PageVideoCopy Px1, Py1, Vpage(), 1
LOOP UNTIL INKEY$ <> ""

FOR I = 0 TO 100
Rel.BoxT Vpage(), I, I, (ScrnXmax + 1) - I, (ScrnYmax + 1) - I, 255 - I
NEXT I
Rel.PageVideoCopy Px1, Px2, Vpage(), 1

DO
Rel.LineT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), 16 + INT(RND * 230)
Rel.EllipseT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.BoxT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), 16 + INT(RND * 220)
Rel.EllipseFT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.KgenFont Vpage(), 0, 180, "Translucent Full Screen Drawing Primitives", 70, FALSE
Rel.KgenFont Vpage(), 0, 190, "Clipping Supported!!!!", 70, FALSE
Rel.PageVideoCopy Px1, Px2, Vpage(), 1
LOOP UNTIL INKEY$ <> ""



'===========Clipped
CLS

ScrnXmax = 179
ScrnYmax = 159
Px1 = 70
Py1 = 20
Rel.PageInit Vpage(), ScrnXmax, ScrnYmax
Rel.PageClear Vpage()
Rel.PageCls Vpage(), 199
Rel.PageVideoCopy Px1, Py1, Vpage(), 1


DO
Rel.Box Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.Pset Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.Line Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 255)
Rel.EllipseF Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.Ellipse Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.KgenFont Vpage(), 0, 140, "Clipped", 70, FALSE
Rel.PageVideoCopy Px1, Py1, Vpage(), 1
LOOP UNTIL INKEY$ <> ""
Rel.PageCls Vpage(), 155


DO
Rel.Sprite Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0
Rel.SpriteCT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 150
Rel.SpriteT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0
Rel.SpriteC Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 100
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, -6
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array(), 0, 6

Rel.Sprite Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0
Rel.SpriteCT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 150
Rel.SpriteT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0
Rel.SpriteC Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 100
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, -6
Rel.SpriteG Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), Array2(), 0, 6

Rel.KgenFont Vpage(), 0, 140, "Sprites.", 70, FALSE
Rel.PageVideoCopy Px1, Py1, Vpage(), 1
LOOP UNTIL INKEY$ <> ""

FOR I = 0 TO 100
Rel.BoxT Vpage(), I, I, (ScrnXmax + 1) - I, (ScrnYmax + 1) - I, 255 - I
NEXT I
Rel.PageVideoCopy Px1, Py1, Vpage(), 1

DO
Rel.LineT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), 16 + INT(RND * 230)
Rel.EllipseT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.BoxT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * ScrnXmax), INT(RND * ScrnYmax), 16 + INT(RND * 220)
Rel.EllipseFT Vpage(), INT(RND * ScrnXmax), INT(RND * ScrnYmax), INT(RND * 80), INT(RND * 40), 16 + INT(RND * 200)
Rel.KgenFont Vpage(), 0, 140, "Translucent", 70, FALSE
Rel.PageVideoCopy Px1, Py1, Vpage(), 1
LOOP UNTIL INKEY$ <> ""

ERASE Array, Array2

END SUB

SUB DoMeteor STATIC

Rel.PageInit Vpage(), 319, 199

CONST PI! = 3.141593
CONST Xmin = 0, Ymin = 0
CONST Xmax = 320, Ymax = 200
CONST Xmid = 160, Ymid = 100

CONST Starspeed! = .5
CONST MagRot = 6
CONST MaxCounter = 1000

DIM Mag  AS INTEGER
DIM oldMag  AS INTEGER


Mag = MagRot

DIM Num
Num = 70

DIM Sintab(359) AS LONG
DIM Costab(359) AS LONG
DIM Stars(1 TO Num)  AS Startype

REDIM Meteor(1 TO 1)
REDIM MeteorIndex(1 TO 1)


'CreateTable
FOR I = 0 TO 359                                'create sine and cosine
   Sintab(I) = SIN(I * (PI! / 180)) * 256                'look up tables to speed up
   Costab(I) = COS(I * (PI! / 180)) * 256                'the math
NEXT



'Init

FOR I = 1 TO Num
        Angle = INT(RND * 360)
        radius = 20 + INT(RND * 180)

        X = Xmid + (Costab(Angle) * radius) \ 256
        Y = Ymid + (Sintab(Angle) * radius) \ 256
        Stars(I).X = X
        Stars(I).Y = Y
        Stars(I).R = radius
        Stars(I).A = Angle
        Stars(I).S = .5
        Stars(I).C = 1 + INT(RND * 100)

NEXT I




FileName$ = ""
InitImageData FileName$, Meteor()
MakeImageIndex Meteor(), MeteorIndex()


DO
        Rel.PageClear Vpage()
        Counter = (Counter MOD MaxCounter) + 1
        IF Counter = 1 THEN
                IF SGN(oldMag) = 1 THEN
                        Mag = -MagRot
                ELSE
                        Mag = MagRot
                END IF
        ELSEIF Counter = MaxCounter \ 2 THEN
                oldMag = Mag
                Mag = 0
        END IF

        GOSUB MoveStars
        GOSUB DrawStars
        Rel.PageVideoCopy 0, 0, Vpage(), 1


LOOP UNTIL INKEY$ <> ""
ERASE Stars, Meteor, MeteorIndex

EXIT SUB

DrawStars:
   FOR I = 1 TO Num
        SELECT CASE Stars(I).R
                CASE 20 TO 50
                        Idx = 4
                CASE 51 TO 80
                        Idx = 3
                CASE 81 TO 110
                        Idx = 2
                CASE ELSE
                        Idx = 1
        END SELECT
        Rel.Sprite Vpage(), Stars(I).X, Stars(I).Y, Meteor(), MeteorIndex(Idx)
   NEXT I

RETURN

MoveStars:
        FOR I = 1 TO Num
                Stars(I).A = Stars(I).A + Mag
                        IF SGN(Mag) = 1 THEN
                                IF Stars(I).A > 359 THEN Stars(I).A = 0
                        ELSE
                                IF Stars(I).A < 0 THEN Stars(I).A = 359
                        END IF

                Stars(I).S = Stars(I).S + Starspeed
                Stars(I).R = Stars(I).R + Stars(I).S
                Stars(I).X = Xmid + (Costab(Stars(I).A) * Stars(I).R) \ 256
                        IF Stars(I).X > Xmax - 4 OR Stars(I).X < Xmin + 4 THEN GOSUB Recalc
                Stars(I).Y = Ymid + (Sintab(Stars(I).A) * Stars(I).R) \ 256
                        IF Stars(I).Y > Ymax - 4 OR Stars(I).Y < Ymin + 4 THEN GOSUB Recalc
        NEXT I
RETURN

Recalc:
        Angle = INT(RND * 360)
        radius = 20 + INT(RND * 30)

        X = Xmid + (Costab(Angle) * radius) \ 256
        Y = Ymid + (Sintab(Angle) * radius) \ 256

        Stars(I).X = X
        Stars(I).Y = Y
        Stars(I).R = radius
        Stars(I).A = Angle
        Stars(I).S = .5

RETURN

END SUB

SUB DoPal

Rel.PageInit Vpage(), X1max, Y1max
Rel.PageClear Vpage()
FOR I = 0 TO 98
        Rel.Box Vpage(), I, I, 319 - I, 199 - I, 32 + I
NEXT I

Rel.KgenFont Vpage(), 0, 0, "Fade/FadeToPal/RotatePalF|B/NegativePal", 24, FALSE
Rel.PageVideoCopy 0, 0, Vpage(), 1


Rel.FadeToPal RGBpal, 80


Rel.Fade INT(RND * 64), INT(RND * 64), INT(RND * 64), 80

Rel.FadeToPal RGBpal, 80

C$ = INPUT$(1)
Rel.NegativePal
C$ = INPUT$(1)
Rel.FadeX 50, 90, 0, 0, 0, 100
Rel.FadeToPalX 50, 90, RGBpal, 100
C$ = INPUT$(1)

Rel.NegativePal
DO
        Rel.RotatePalF 32, 255
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
LOOP UNTIL INKEY$ <> ""

Rel.SwitchToPal RGBpal
DO
        Rel.RotatePalB 32, 255
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
LOOP UNTIL INKEY$ <> ""

DO
        Rel.RotatePalF 32, 255
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
LOOP UNTIL INKEY$ <> ""

END SUB

SUB DoSprites STATIC
REDIM Spr(30)  AS SpriteType

'Init Values
FOR I = 0 TO UBOUND(Spr)
        Spr(I).X = INT(RND * 300)
        Spr(I).Y = INT(RND * 190)
        Spr(I).XV = -5 + INT(RND * 10)              'velocity
        Spr(I).YV = -5 + INT(RND * 10)
        Spr(I).PutMode = INT(RND * 5)
        Spr(I).Gamma = -10 + INT(RND * 20)      'GammaVal
        Spr(I).id = INT(RND * 2)
NEXT I



ScrnXmax = 319
ScrnYmax = 199
Px1 = 0
Py1 = 0

'Background Page
Rel.PageInit Vpage2(), ScrnXmax, ScrnYmax
Rel.SetActivePage Vpage2()
FOR I = 0 TO 98
        Rel.Box Vpage2(), I, I, 319 - I, 199 - I, 32 + I
NEXT I
Clr = 15
FOR I = 0 TO 359
        Clr = Clr + 1: IF Clr > 255 THEN Clr = 16
        R = 180
        Angle! = I * 3.141593 / 180
        TX = COS(Angle!) * R
        TY = SIN(Angle!) * R
        Rel.LineT Vpage2(), 160, 100, 160 + TX, 100 + TY, Clr
NEXT I
Rel.KgenFont Vpage2(), 0, 0, "Sprites Galore!!!!!!", 23, TRUE
Rel.KgenFont Vpage2(), 0, 100, "Possibilities are endless :*)", 23, FALSE
Rel.KgenFont Vpage2(), 0, 180, "Http://Auraflow.Curvehead.Com", 23, FALSE


'Standard Page
Rel.PageInit Vpage(), ScrnXmax, ScrnYmax
Rel.SetActivePage Vpage2()

Rel.PageClear Vpage()
'Get Sprites


Size = Rel.Size(0, 0, 15, 15)
DIM Array(Size) AS INTEGER
C = 185
FOR X = 0 TO 15
        C = C + 1
        Rel.Box Vpage(), 100 + X, 100 + X, 115 - X, 115 - X, C
NEXT X
Rel.Get Vpage(), 100, 100, 115, 115, Array(), 0
Rel.Box Vpage(), 100, 100, 115, 115, 15
Rel.Sprite Vpage(), 0, 0, Array(), 0


Rel.PageClear Vpage()
Size = Rel.Size(20, 30, 80, 70)
DIM Array2(Size) AS INTEGER
C = 175
Xc = 50
Yc = 50
FOR X = 0 TO 15
        C = C + 1
        Rel.EllipseF Vpage(), Xc, Yc, 32 - X, 20 - X, C
NEXT X
Rel.EllipseF Vpage(), Xc, Yc, 10, 5, 0
Rel.Get Vpage(), 20, 30, 80, 70, Array2(), 0

Rel.CopyPage Vpage(), Vpage2()
Rel.PageVideoCopy 0, 0, Vpage(), 1
Rel.FadeToPal RGBpal, 100




DO
        Rel.CopyPage Vpage(), Vpage2()
        FOR I = 0 TO UBOUND(Spr)
                Spr(I).X = Spr(I).X + Spr(I).XV
                Spr(I).Y = Spr(I).Y + Spr(I).YV
                IF Spr(I).X < -20 THEN
                        Spr(I).XV = -Spr(I).XV
                ELSEIF Spr(I).X > ScrnXmax THEN
                        Spr(I).XV = -Spr(I).XV
                END IF
                IF Spr(I).Y < -20 THEN
                        Spr(I).YV = -Spr(I).YV
                ELSEIF Spr(I).Y > ScrnYmax THEN
                        Spr(I).YV = -Spr(I).YV
                END IF
          IF Spr(I).id < 1 THEN
                SELECT CASE Spr(I).PutMode
                        CASE 0
                                Rel.Sprite Vpage(), Spr(I).X, Spr(I).Y, Array(), 0
                        CASE 1
                                Rel.SpriteT Vpage(), Spr(I).X, Spr(I).Y, Array(), 0
                        CASE 2
                                Rel.SpriteCT Vpage(), Spr(I).X, Spr(I).Y, Array(), 0, 145
                        CASE 3
                                Rel.SpriteG Vpage(), Spr(I).X, Spr(I).Y, Array(), 0, Spr(I).Gamma
                        CASE 4
                                Rel.SpriteC Vpage(), Spr(I).X, Spr(I).Y, Array(), 0, 100
                        CASE ELSE
                                Rel.Sprite Vpage(), Spr(I).X, Spr(I).Y, Array(), 0
                END SELECT
        ELSE
                SELECT CASE Spr(I).PutMode
                        CASE 0
                                Rel.Sprite Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0
                        CASE 1
                                Rel.SpriteT Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0
                        CASE 2
                                Rel.SpriteCT Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0, 145
                        CASE 3
                                Rel.SpriteG Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0, Spr(I).Gamma
                        CASE 4
                                Rel.SpriteC Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0, 100
                        CASE ELSE
                                Rel.Sprite Vpage(), Spr(I).X, Spr(I).Y, Array2(), 0
                END SELECT
        END IF
        NEXT I

        Rel.PageVideoCopy Px1, Py1, Vpage(), 1

LOOP UNTIL INKEY$ <> ""

ERASE Array, Array2, Spr


END SUB

SUB Init
Path$ = "C:\Temp\RelGFX\MiniRPG\"   'CHANGE THIS TO THE DIR YOU UNZIPPED THE FILE
Path$ = ""   'CHANGE THIS TO THE DIR YOU UNZIPPED THE FILE
Rel.PageInit Vpage(), X1max, Y1max
END SUB

'* InitImageData() subroutine:
'* Initializes an integer array with image data - this must be done before
'* displaying an image using the PUT(graphics) statement. The calling value
'* of FileName$ dictates whether the data should be read directly from an
'* image file or from DATA statements (see below).
'*
'* Parameters:
'*    FileName$ - The name of the image file to load. This must include the
'*                path to the file if it does not reside in the current
'*                directory. If FileName$ is an empty string (""), image
'*                data is read from DATA statements.
'* ImageArray() - Dynamic, integer array to hold the image data.
'*
'* Note: Before calling InitImageData() to initialize images from DATA
'*       statements, use an appropriate RESTORE statement to ensure the
'*       correct DATA statements are read.
'*
SUB InitImageData (FileName$, ImageArray())

    IF FileName$ <> "" THEN
        '***** Read image data from file *****

        'Establish size of integer array required.
        FileNo = FREEFILE
        OPEN FileName$ FOR BINARY AS #FileNo
        Ints = (LOF(FileNo) - 7) \ 2
        CLOSE #FileNo
        REDIM ImageArray(1 TO Ints)

        'Load image data directly into array memory.
        DEF SEG = VARSEG(ImageArray(1))
        BLOAD FileName$, 0
        DEF SEG
    ELSE
        '***** Read image data from DATA statements *****

        'Establish size of integer array required.
        READ IntCount
        REDIM ImageArray(1 TO IntCount)

        'READ image DATA into array.
        FOR n = 1 TO IntCount
            READ X
            ImageArray(n) = X
        NEXT n
    END IF



END SUB

'* MakeImageIndex() subroutine:
'* Constructs an image position index for the images held in an image array.
'*
'* Parameters:
'* ImageArray() - Dynamic, integer array holding images to be indexed.
'* IndexArray() - Dynamic, integer array to hold the index for images in
'*                ImageArray().
'*
SUB MakeImageIndex (ImageArray(), IndexArray())

    'The index will initially be built in a temporary array, allowing
    'for the maximum 1000 images per file.
    DIM Temp(1 TO 1000)
    Ptr& = 1: IndexNo = 1: LastInt = UBOUND(ImageArray)
    DO
        Temp(IndexNo) = Ptr&
        IndexNo = IndexNo + 1

        'Evaluate descriptor of currently referenced image to
        'calculate the beginning of the next image.
        X& = (ImageArray(Ptr&) \ 8) * (ImageArray(Ptr& + 1)) + 4
        IF X& MOD 2 THEN X& = X& + 1
        Ptr& = Ptr& + (X& \ 2)
    LOOP WHILE Ptr& < LastInt

    LastImage = IndexNo - 1

    'Copy the image index values into the actual index array.
    REDIM IndexArray(1 TO LastImage)
    FOR n = 1 TO LastImage
        IndexArray(n) = Temp(n)
    NEXT n

END SUB

SUB Rel.AddByte (IntVal, LowByte, HiByte, ByteFlag) STATIC
'Adds a Byte or two Bytes to an Integer value
'Used for memory saving :*)

'IntVal=Value  of Integer to Pad
'ByteVal1=Value of first byte
'ByteVal2=Value of second byte
'ByteFlag=check to see if both or first or second only byte to add
'IF ByteFlag:
'0=Add Both Bytes
'1=Add the Low Byte
'2=Add the Hi Byte

FB = IntVal \ 256
SB = IntVal AND 255

SELECT CASE ByteFlag
        CASE 0     'Add both bytes
                IntVal = (HiByte * 256) OR LowByte
        CASE 1     'Add only the Low byte
                IntVal = (FB * 256) OR LowByte
        CASE 2     'Add only the Hi byte
                IntVal = (HiByte * 256) OR SB
        CASE ELSE
                IntVal = (HiByte * 256) OR LowByte
END SELECT

END SUB

SUB Rel.Box (VideoBuf(), X1, Y1, X2, Y2, Clr)
'Draws a Box to Videobuff in color Clr
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

ClipX = 0
ClipY = 0
CropX = 0
CropY = 0


'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)

'Clip or Crop
IF By1 < 0 THEN
        IF By1 + Dy < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
        ClipY = -1
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN
                Dy = Dy - (Ndy - Scr.Ymax)
                CropY = -1
        END IF
END IF

IF Bx1 < 0 THEN
        IF Bx1 + Dx < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
        ClipX = -1
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN
                Dx = Dx - (Ndx - Scr.Xmax)
                CropX = -1
        END IF
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

'Top Line
IF NOT ClipY THEN
        FOR Xa = 0 TO Dx
                POKE VpSaddr& + Xa, Clr
        NEXT Xa
END IF

'Mid Vertlines
FOR Ya = 0 TO Dy
        IF NOT ClipX THEN POKE VpSaddr&, Clr
        IF NOT CropX THEN POKE VpSaddr& + Dx, Clr
        VpSaddr& = VpSaddr& + (Scr.Xmax + 1)
NEXT Ya

'Correct Address
VpSaddr& = VpSaddr& - (Scr.Xmax + 1)
'Bottom Line
IF NOT CropY THEN
        FOR Xa = 0 TO Dx
                POKE VpSaddr& + Xa, Clr
        NEXT Xa
END IF


DEF SEG

END SUB

SUB Rel.BoxF (VideoBuf(), X1, Y1, X2, Y2, Clr)

'Draws a filled Box to Videobuff in color Clr
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Filled Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)
'Clip or Crop
IF By1 < 0 THEN
        IF Dy + By1 < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN Dy = Dy - (Ndy - Scr.Ymax)
END IF

IF Bx1 < 0 THEN
        IF Dx + Bx1 < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN Dx = Dx - (Ndx - Scr.Xmax)
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Dy
FOR Xa = 0 TO Dx
        POKE VpSaddr& + Xa, Clr
NEXT Xa
        VpSaddr& = VpSaddr& + Scr.Xmax + 1
NEXT Ya

DEF SEG

END SUB

SUB Rel.BoxFT (VideoBuf(), X1, Y1, X2, Y2, Clr)
'Draws a Filled Box to Videobuff in color Clr. Translucently!!!
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Filled Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)
'Clip or Crop
IF By1 < 0 THEN
        IF Dy + By1 < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN Dy = Dy - (Ndy - Scr.Ymax)
END IF

IF Bx1 < 0 THEN
        IF Dx + Bx1 < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN Dx = Dx - (Ndx - Scr.Xmax)
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

TempC = Clr AND 15
BaseColor = Clr - TempC

FOR Ya = 0 TO Dy
FOR Xa = 0 TO Dx
        DestCol = PEEK(VpSaddr& + Xa) AND 15
        C = ((TempC + DestCol) \ 2) + BaseColor
        POKE VpSaddr& + Xa, C
NEXT Xa
        VpSaddr& = VpSaddr& + Scr.Xmax + 1
NEXT Ya

DEF SEG


END SUB

SUB Rel.BoxT (VideoBuf(), X1, Y1, X2, Y2, Clr)
'Draws a Box to Videobuff in color Clr. Translucently!!!
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

ClipX = 0
ClipY = 0
CropX = 0
CropY = 0


'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)

'Clip or Crop
IF By1 < 0 THEN
        IF By1 + Dy < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
        ClipY = -1
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN
                Dy = Dy - (Ndy - Scr.Ymax)
                CropY = -1
        END IF
END IF

IF Bx1 < 0 THEN
        IF Bx1 + Dx < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
        ClipX = -1
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN
                Dx = Dx - (Ndx - Scr.Xmax)
                CropX = -1
        END IF
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

TempC = Clr AND 15
BaseColor = Clr - TempC

'Top Line
IF NOT ClipY THEN
        FOR Xa = 0 TO Dx
                DestCol = PEEK(VpSaddr& + Xa) AND 15
                POKE VpSaddr& + Xa, ((DestCol + TempC) \ 2) + BaseColor
        NEXT Xa
END IF

'Mid Vertlines
FOR Ya = 0 TO Dy
        IF NOT ClipX THEN
                DestCol = PEEK(VpSaddr&) AND 15
                POKE VpSaddr&, ((DestCol + TempC) \ 2) + BaseColor
        END IF
        IF NOT CropX THEN
                DestCol = PEEK(VpSaddr& + Dx) AND 15
                POKE VpSaddr& + Dx, ((DestCol + TempC) \ 2) + BaseColor
        END IF
        VpSaddr& = VpSaddr& + (Scr.Xmax + 1)
NEXT Ya

'Correct Address
VpSaddr& = VpSaddr& - (Scr.Xmax + 1)
'Bottom Line
IF NOT CropY THEN
        FOR Xa = 0 TO Dx
                DestCol = PEEK(VpSaddr& + Xa) AND 15
                POKE VpSaddr& + Xa, ((DestCol + TempC) \ 2) + BaseColor
        NEXT Xa
END IF


DEF SEG


END SUB

FUNCTION Rel.Collide (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Returns the color of the collided color in videobuf
'used for collision detection

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT FUNCTION
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT FUNCTION
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                BuffCol = PEEK(StartPageOff + Xa)
                IF BuffCol THEN
                        Rel.Collide = BuffCol
                        EXIT FUNCTION
                END IF
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG
Rel.Collide = 0

END FUNCTION

SUB Rel.CopyPage (DestBuffer(), SrcBuffer())
'Copies the value of SrcBuffer to DestBuffer
'very fast screen refresh

MaxElem = UBOUND(DestBuffer)
FOR I = 0 TO MaxElem
        DestBuffer(I) = SrcBuffer(I)
NEXT I

END SUB

SUB Rel.Ellipse (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, Clr)
'Original Code by Rich Geldreich
'Taken from the ABC packets and converted by me :*)
'Draws an ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Clipping supported!!!

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))


  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.Line VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, Clr
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.Line VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, Clr
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse

          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipse

  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse

          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
  END IF

DEF SEG

EXIT SUB

PutPixelEllipse:

NotClip = (((Xput < 0) + (Yput < 0) + (Xput > Scr.Xmax) + (Yput > Scr.Ymax)) = 0)
IF NotClip THEN POKE YsegLUT(Yput) + Xput + VpSaddr, Clr

RETURN

END SUB

SUB Rel.EllipseF (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, Clr)
'Draws a filled ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Clipping supported!!!

  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.Line VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, Clr
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.Line VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, Clr
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
          Rel.Line VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, Clr
          Rel.Line VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, Clr
          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.Line VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, Clr
          Rel.Line VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, Clr
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.Line VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, Clr
          Rel.Line VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, Clr
  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, Clr
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, Clr
          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, Clr
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, Clr
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.Line VideoBuf(), Xcenter, Ycenter + X, Xcenter, Ycenter + X, Clr
          Rel.Line VideoBuf(), Xcenter, Ycenter - X, Xcenter, Ycenter - X, Clr
  END IF

END SUB

SUB Rel.EllipseFT (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, Clr)
'Draws a filled ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'translucently!!!! Clipping supported!!!

  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.LineT VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, Clr
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.LineT VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, Clr
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, Clr
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, Clr
          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, Clr
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, Clr
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, Clr
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, Clr
  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, Clr
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, Clr
          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, Clr
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, Clr
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.LineT VideoBuf(), Xcenter, Ycenter + X, Xcenter, Ycenter + X, Clr
          Rel.LineT VideoBuf(), Xcenter, Ycenter - X, Xcenter, Ycenter - X, Clr
  END IF

END SUB

SUB Rel.EllipseT (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, Clr)
'Original Code by Rich Geldreich
'Taken from the ABC packets and converted by me :*)
'Draws an ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Translucently!!!Clipping supported!!!

DIM Address AS LONG

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

TempC = Clr AND 15
BaseColor = Clr - TempC



  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.LineT VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, Clr
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.LineT VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, Clr
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT

          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT

  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT

          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
  END IF

DEF SEG

EXIT SUB

PutPixelEllipseT:

NotClip = (((Xput < 0) + (Yput < 0) + (Xput > Scr.Xmax) + (Yput > Scr.Ymax)) = 0)
IF NotClip THEN
        Address = YsegLUT(Yput) + Xput + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((DestColor + TempC) \ 2) + BaseColor
END IF

RETURN

END SUB

SUB Rel.Fade (R, G, B, Counts) STATIC
'This sub fades the current palette to the specified RGB color
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?


TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE

ColorVal = 0
 
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

IF Counts < 1 THEN Counts = 1
'Morphing algorithm used  yay!!!!
FOR I = 0 TO 255
        PalDiff = R - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = G - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = B - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = 0 TO 255
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        OUT &H3C8, 0
        FOR J = 0 TO 255
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE FadePal


END SUB

SUB Rel.FadeStep (StartCol, EndCol, R%, G%, B%) STATIC
'This sub fades the current palette to the specified RGB color
'in steps, so if you want to fade fully call this sub 64 times
'from StartColor to Endcolor ie, selective fade

IF StartCol > EndCol THEN SWAP StartCol, EndCol

I = I + 1

IF I > 63 THEN
        I = 0
        EXIT SUB
END IF

FOR J = StartCol TO EndCol


        Rel.ReadRGB J, RD, GN, BLL

        IF R% > RD THEN
                RD = RD + 1
        ELSEIF R% < RD THEN
                RD = RD - 1
        ELSE
                'Do nothing
        END IF

        IF G% > GN THEN
                GN = GN + 1
        ELSEIF G% < GN THEN
                GN = GN - 1
        ELSE
                'Do nothing
        END IF

        IF B% > BLL THEN
                BLL = BLL + 1
        ELSEIF B% < BLL THEN
                BLL = BLL - 1
        ELSE
                'Do nothing
        END IF

        Rel.WriteRGB J, RD, GN, BLL

NEXT J

END SUB

SUB Rel.FadeToPal (PalString$, Counts) STATIC
'This sub fades the current palette to the specified palette comtained
'in the 768 byte palstring$
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?

TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE      'Current pal
REDIM TempPalArray2(2, 255) AS SINGLE     'PalString$ pal
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE


ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray2(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray2(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray2(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF Counts < 1 THEN Counts = 1

'Morphing algorithm used  yay!!!!
FOR I = 0 TO 255
        PalDiff = TempPalArray2(0, I) - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = TempPalArray2(1, I) - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = TempPalArray2(2, I) - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = 0 TO 255
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        OUT &H3C8, 0
        FOR J = 0 TO 255
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE TempPalArray2
ERASE FadePal


END SUB

SUB Rel.FadeToPalStep (StartCol, EndCol, PalString$) STATIC

'This sub fades the current palette to the palette in the
'768 byte Palstring$
'in steps, so if you want to fade fully call this sub 64 times
'from StartColor to Endcolor ie, selective fade

PalI = PalI + 1

IF PalI > 63 THEN
        PalI = 0
        EXIT SUB
END IF


REDIM TempPalArray(2, 255) AS INTEGER      'Current pal

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF StartCol > EndCol THEN SWAP StartCol, EndCol


FOR J = StartCol TO EndCol


        Rel.ReadRGB J, RD, GN, BLL
        R% = TempPalArray(0, J)
        IF R% > RD THEN
                RD = RD + 1
        ELSEIF R% < RD THEN
                RD = RD - 1
        ELSE
                'Do nothing
        END IF

        G% = TempPalArray(1, J)
        IF G% > GN THEN
                GN = GN + 1
        ELSEIF G% < GN THEN
                GN = GN - 1
        ELSE
                'Do nothing
        END IF

        B% = TempPalArray(2, J)
        IF B% > BLL THEN
                BLL = BLL + 1
        ELSEIF B% < BLL THEN
                BLL = BLL - 1
        ELSE
                'Do nothing
        END IF

        Rel.WriteRGB J, RD, GN, BLL

NEXT J

ERASE TempPalArray


END SUB

SUB Rel.FadeToPalX (StartCol, EndCol, PalString$, Counts) STATIC

'This sub fades the current palette to the specified palette comtained
'in the 768 byte palstring$ form Start col to endcol
'ie selective fade
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?

TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE      'Current pal
REDIM TempPalArray2(2, 255) AS SINGLE     'PalString$ pal
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE


ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray2(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray2(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray2(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF Counts < 1 THEN Counts = 1

'Morphing algorithm used  yay!!!!
IF StartCol > EndCol THEN SWAP StartCol, EndCol
FOR I = StartCol TO EndCol
        PalDiff = TempPalArray2(0, I) - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = TempPalArray2(1, I) - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = TempPalArray2(2, I) - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = StartCol TO EndCol
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        FOR J = StartCol TO EndCol
                OUT &H3C8, J
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE TempPalArray2
ERASE FadePal

END SUB

SUB Rel.FadeX (StartCol, EndCol, R, G, B, Counts) STATIC
'This sub fades the current palette to the specified RGB color
'from StartColor to Endcolor ie, selective fade
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?


TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE

ColorVal = 0

FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

IF Counts < 1 THEN Counts = 1
'Morphing algorithm used  yay!!!!
IF StartCol > EndCol THEN SWAP StartCol, EndCol

FOR I = StartCol TO EndCol
        PalDiff = R - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = G - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = B - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = StartCol TO EndCol
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        FOR J = StartCol TO EndCol
                OUT &H3C8, J
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE FadePal

END SUB

FUNCTION Rel.FastKB STATIC
'Faster replacement for inkey$
'Break codes(Scancode+128) from 215 are ignored.
'returns the scancode for the pressed key
'the list of scancodes can be found at QB's help file.
IF NOT KeyReProg THEN
        OUT &H60, &HF3                          'Inform keyboard
        FOR Delay& = 1 TO 1000: NEXT Delay&      'Just a precaution(Settle)
        OUT &H60, 0                             'send fast typematic rate
        KeyReProg = -1
END IF

        Code = INP(&H60)
        IF Code > 215 THEN
                Rel.FastKB = OldCode
        ELSE
                Rel.FastKB = Code
                OldCode = Code
        END IF

        'Memory 40:1A/1C
        'What this does is point the head to tail of the key buffer
        DEF SEG = &H40                  'Clears the pending key buffer
        POKE &H1A, PEEK(&H1C)           'Set head pointer to buffer start...
                                        'For the annoying beep :*)

END FUNCTION

SUB Rel.Font (VideoBuf(), X%, Y%, Text$, Centered%, FontArray(), FontArrayIndex())
'Prints a font in Pseudo true-type columns to videobuf
'Text$=is the string to print
'X,Y are the top left coords(in pixel) of the string
'if Centered then the string is printed at the center
'Font() and FontArray() are PP256 made index
'to make your own fonts, use PP256's tile editor :*)

XX% = X%
YY% = Y%
IF NOT Centered% THEN

        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                Rel.Sprite VideoBuf(), XX%, YY%, FontArray(), FontArrayIndex(FontChar)
                XX% = XX% + (FontArray(FontArrayIndex(FontChar%)) \ 8)
        NEXT I%

ELSE            'Centered

        StrLen% = 0
        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                StrLen% = StrLen% + (FontArray(FontArrayIndex(FontChar%)))
        NEXT I%
        StrLen% = StrLen% \ 8  'Calculate length
        XX% = ((Scr.Xmax + 1) - StrLen%) \ 2
        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                Rel.Sprite VideoBuf(), XX%, YY%, FontArray(), FontArrayIndex(FontChar)
                XX% = XX% + (FontArray(FontArrayIndex(FontChar%)) \ 8)
        NEXT I%

END IF

END SUB

SUB Rel.Get (VideoBuf(), X1, Y1, X2, Y2, Sprite(), SpriteOffset)
'Works like QB's GET statement
'the array made is QB GET/PUT compatible
'gets the sprite from X1,Y1,X2,Y2 from VideoBuff
'and puts the values into Sprite with an offset of SpriteOffset.

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = (X2 - X1) + 1
oYsize = (Y2 - Y1) + 1
Xsize = oXsize
Ysize = oYsize

NewX = X1
NewY = Y1

ScrXlen = Scr.Xmax + 1


SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))

'Save Width
Sprite(SpriteOffset) = Xsize * 8
'Save Height
Sprite(SpriteOffset + 1) = Ysize


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF

BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = BuffSeg
        Clr = PEEK(StartPageOff + Xa)
        DEF SEG = SprSeg
        POKE SprOff + Xa, Clr
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.KgenFont (VideoBuf(), X, Y, Font$, MinColor, Italic)
'=======Prints system fonts on VideoBufn  specified by X,Y
'=======Uses 8 colors from mincolor to Mincolor+8
'=======Font$ is the string, italic? Duh!!!!!
'======================================================

DIM e(7): e(0) = 1: FOR F = 1 TO 7: e(F) = e(F - 1) + e(F - 1): NEXT F


XXX = X
YYY = Y

IF X = Scr.Xmax + 1 THEN X = ((Scr.Xmax + 1) \ 2) - (4 * LEN(Font$))

DEF SEG = &HFFA6
FOR A = 1 TO LEN(Font$)
KC = 0
IF Italic THEN
        Ita = 8
ELSE
        Ita = 0
END IF

 X = X + 8
 d = ASC(MID$(Font$, A, 1)) * 8 + 14
 FOR B = 0 TO 7
  FOR C = 0 TO 7
   IF PEEK(B + d) AND e(C) THEN
        DEF SEG = VARSEG(VideoBuf(0))
        NotClip = (((((X - C) + Ita) < 0) + ((Y + B) < 0) + (((X - C) + Ita) > Scr.Xmax) + ((Y + B) > Scr.Ymax)) = 0)
        IF NotClip THEN POKE YsegLUT((Y + B)) + ((X - C) + Ita) + VARPTR(VideoBuf(2)), MinColor + KC
        DEF SEG = &HFFA6
   END IF
  NEXT C
        KC = KC MOD 8 + 1
           IF Italic THEN
                Ita = Ita - 1
           END IF
 NEXT B
NEXT A

DEF SEG

X = XXX
Y = YYY

END SUB

SUB Rel.Line (VideoBuf(), X, Y, X2, Y2, Clr)
'Original Code by Kurt Kuzba
'Taken from the ABC packets and converted by me :*)
'Draws a Diagonal line specified by X,Y,X2,Y2
'Clipping Supported and Swaps values which are not in order.


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

I = 0
Slope = 0
Eterm = 0

IF (X2 - X) > 0 THEN
     SX = 1
ELSE
     SX = -1
END IF
Dx = ABS(X2 - X)


IF (Y2 - Y) > 0 THEN
     SY = 1
ELSE
     SY = -1
END IF
Dy = ABS(Y2 - Y)

IF (Dy > Dx) THEN
        Slope = 1
        SWAP X, Y
        SWAP Dx, Dy
        SWAP SX, SY
END IF
Eterm = 2 * Dy - Dx

FOR I = 0 TO Dx - 1
   IF Slope = 1 THEN
     NotClip = (((Y < 0) + (X < 0) + (Y > Scr.Xmax) + (X > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(X) + Y + VpSaddr, Clr
   ELSE
     NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(Y) + X + VpSaddr, Clr
   END IF

   WHILE Eterm >= 0
      Y = Y + SY: Eterm = Eterm - 2 * Dx
   WEND
   X = X + SX: Eterm = Eterm + 2 * Dy
NEXT
     NotClip = (((X2 < 0) + (Y2 < 0) + (X2 > Scr.Xmax) + (Y2 > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(Y2) + X2 + VpSaddr, Clr

DEF SEG

END SUB

SUB Rel.LineT (VideoBuf(), X, Y, X2, Y2, Clr)
'Original Code by Kurt Kuzba
'Taken from the ABC packets and converted by me :*)
'Draws a Diagonal line specified by X,Y,X2,Y2. Translucently!!!
'Clipping Supported and Swaps values which are not in order.


DIM Address AS LONG
DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

I = 0
Slope = 0
Eterm = 0

TempC = Clr AND 15
BaseColor = Clr - TempC

IF (X2 - X) > 0 THEN
     SX = 1
ELSE
     SX = -1
END IF
Dx = ABS(X2 - X)


IF (Y2 - Y) > 0 THEN
     SY = 1
ELSE
     SY = -1
END IF
Dy = ABS(Y2 - Y)

IF (Dy > Dx) THEN
        Slope = 1
        SWAP X, Y
        SWAP Dx, Dy
        SWAP SX, SY
END IF
Eterm = 2 * Dy - Dx

FOR I = 0 TO Dx - 1
   IF Slope = 1 THEN
     NotClip = (((Y < 0) + (X < 0) + (Y > Scr.Xmax) + (X > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(X) + Y + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF
   ELSE
     NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(Y) + X + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF
   END IF

   WHILE Eterm >= 0
      Y = Y + SY: Eterm = Eterm - 2 * Dx
   WEND
   X = X + SX: Eterm = Eterm + 2 * Dy
NEXT
     NotClip = (((X2 < 0) + (Y2 < 0) + (X2 > Scr.Xmax) + (Y2 > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(Y2) + X2 + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF

DEF SEG

END SUB

SUB Rel.LoadPal (File$, PalString$, Switch) STATIC
'Loads a 768 pal to PalString$
'File$=File to load
'PalString$=768 byte pal
'Switch=Flag to switch the current pal to palstring$
'any non-zero for switch will change the current pal

 IF INSTR(File$, ".") = 0 THEN File$ = File$ + ".RGB"

    TempPal$ = SPACE$(768)

    FileNum% = FREEFILE
    OPEN File$ FOR BINARY AS #FileNum%
        GET #FileNum%, , TempPal$
    CLOSE #FileNum%

    IF LEN(TempPal$) <> 768 THEN EXIT SUB



IF Switch THEN

    OUT &H3C8, 0
    FOR I% = 1 TO 768 STEP 3
        OUT &H3C9, ASC(MID$(TempPal$, I%, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 1, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 2, 1))
    NEXT I%

END IF

PalString$ = TempPal$

END SUB

SUB Rel.LoadPalPP256 (File$) STATIC
'Loads and Switches the pal to PP256's pal from File$
'Special thanks goes to Kackurot for this one.

FR = FREEFILE
IF INSTR(File$, ".") = 0 THEN File$ = LEFT$(File$, 8) + ".Pal"
OPEN File$ FOR BINARY AS #FR
    FOR n = 0 TO 255
        GET #FR, , C&
        B = C& \ 65536: C& = C& - B * 65536
        G = C& \ 256: C& = C& - G * 256
        R = C&
        OUT &H3C8, n
        OUT &H3C9, R
        OUT &H3C9, G
        OUT &H3C9, B
     NEXT
CLOSE #FR

END SUB

SUB Rel.NegativePal STATIC
'Makes a seemingly negative effect on the current palette
'very cool!!!

FOR I% = 0 TO 255

 Rel.ReadRGB I%, R%, G%, B%
 Rel.WriteRGB I%, 63 - R%, 63 - G%, 63 - B%

NEXT I%

END SUB

SUB Rel.PageClear (VideoBuf() AS INTEGER) STATIC
'Clears the screen to 0
'Very fast!!!! use this instead of Rel.Cls if you want to clear to color 0

PageL = VideoBuf(0)
PageH = VideoBuf(1)
REDIM VideoBuf(32002) AS INTEGER
VideoBuf(0) = PageL
VideoBuf(1) = PageH
END SUB

SUB Rel.PageCls (VideoBuf(), Clr) STATIC

'Clears the page to color
DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = VARPTR(VideoBuf(2))

        FOR Y = 0 TO Scr.Ymax
        FOR X = 0 TO Scr.Xmax
                POKE X + VpSaddr&, Clr
        NEXT X
                VpSaddr& = VpSaddr& + Scr.Xmax + 1
        NEXT Y
DEF SEG

END SUB

SUB Rel.PageInit (VideoBuf(), Xmax, Ymax) STATIC
'Initializes the dimensions of a page
'and initializes the current page

Scr.Xmax = Xmax
Scr.Ymax = Ymax

'Initializes the lookup table for speed purposes
'Ysegment LUT
FOR I = 0 TO 199
        YsegLUT(I) = I * (Scr.Xmax + 1&)
NEXT I

Xmax& = Scr.Xmax
Ymax& = Scr.Ymax

Size = ((Xmax& + 1) * (Ymax& + 1) + 4) \ 2


REDIM VideoBuf(Size)

'initializes the page
GET (0, 0)-(Scr.Xmax, Scr.Ymax), VideoBuf



END SUB

SUB Rel.PageVideoCopy (X, Y, VideoBuf(), Action) STATIC
'Copies the contents of the page to the screen
'very fast as this uses the normal QB put routine ;-)
'Use Action=1 as much as possible.

SELECT CASE Action
        CASE 1
                PUT (X, Y), VideoBuf, PSET
        CASE 2
                PUT (X, Y), VideoBuf, AND
        CASE 3
                PUT (X, Y), VideoBuf, OR
        CASE 4
                PUT (X, Y), VideoBuf, XOR
        CASE ELSE
END SELECT
END SUB

FUNCTION Rel.Point (VideoBuf(), X, Y)
'Works like QB's Point function

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))
NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
IF NotClip THEN
        Rel.Point = PEEK(YsegLUT(Y) + X + VpSaddr)
ELSE
        Rel.Point = 0
END IF
DEF SEG

END FUNCTION

SUB Rel.Pset (VideoBuf(), X, Y, Clr) STATIC
'Puts a pixel to page
'Clipping supported!!!

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))
NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
IF NotClip THEN POKE YsegLUT(Y) + X + VpSaddr, Clr
DEF SEG
END SUB

SUB Rel.ReadPal (PalString$) STATIC
'Reads the current palette and puts it to a 768 byte string
'palstring$, use this if you loaded the pal from a pp256 format

TempPal$ = SPACE$(768)

OUT &H3C7, 0
FOR I% = 0 TO 255
  MID$(TempPal$, (I% * 3) + 1, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 2, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 3, 1) = CHR$(INP(&H3C9))
NEXT I%

PalString$ = TempPal$

END SUB

SUB Rel.ReadRGB (ColorVal, R, G, B) STATIC
'Reads the RGB values of the color and puts them to R,G, and B.
        OUT &H3C7, ColorVal
        R = INP(&H3C9)
        G = INP(&H3C9)
        B = INP(&H3C9)
END SUB

SUB Rel.RotatePalB (StartCol, EndCol) STATIC
'Rotates the pal Backwards
'colors affected are from Startcol to Endcol

IF StartCol > EndCol THEN SWAP StartCol, EndCol

REDIM TempPal(2, StartCol TO EndCol) AS INTEGER

FOR I = StartCol TO EndCol
        Rel.ReadRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
FOR I = StartCol TO EndCol - 1
        SWAP TempPal(0, I), TempPal(0, I + 1)
        SWAP TempPal(1, I), TempPal(1, I + 1)
        SWAP TempPal(2, I), TempPal(2, I + 1)
NEXT I

FOR I = StartCol TO EndCol
        Rel.WriteRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
ERASE TempPal

END SUB

SUB Rel.RotatePalF (StartCol, EndCol) STATIC
'Rotates the pal Forward
'colors affected are from Startcol to Endcol

IF StartCol > EndCol THEN SWAP StartCol, EndCol

REDIM TempPal(2, StartCol TO EndCol) AS INTEGER

FOR I = StartCol TO EndCol
        Rel.ReadRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
FOR I = EndCol TO StartCol + 1 STEP -1
        SWAP TempPal(0, I), TempPal(0, I - 1)
        SWAP TempPal(1, I), TempPal(1, I - 1)
        SWAP TempPal(2, I), TempPal(2, I - 1)
NEXT I

FOR I = StartCol TO EndCol
        Rel.WriteRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I

ERASE TempPal

END SUB

SUB Rel.SavePal (File$) STATIC
'Saves the current palette to a file.

IF INSTR(File$, ".") = 0 THEN File$ = LEFT$(File$, 8) + ".Pal"

TempPal$ = SPACE$(768)

OUT &H3C7, 0
FOR I% = 0 TO 255
  MID$(TempPal$, (I% * 3) + 1, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 2, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 3, 1) = CHR$(INP(&H3C9))
NEXT I%

FileNum% = FREEFILE
OPEN File$ FOR BINARY AS #FileNum%
PUT #FileNum%, , TempPal$
CLOSE #FileNum%

END SUB

SUB Rel.SetActivePage (VideoBuf())
'Sets the active page
'use this in mutiple page'd programs.
'all writes like Rel.Sprite,Rel.Pset are to VideoBuf()
'after the call unless you set the active page to another page()

Scr.Xmax = (VideoBuf(0) \ 8) - 1
Scr.Ymax = VideoBuf(1) - 1

'Initializes the lookup table for speed purposes
'Ysegment LUT
FOR I = 0 TO Scr.Ymax
        YsegLUT(I) = I * (Scr.Xmax + 1&)
NEXT I

END SUB

FUNCTION Rel.Size (X1, Y1, X2, Y2)
'Calculates the Size of the array
'to be used in QB's GET or Rel.Get

Rel.Size = ((((X2 - X1) + 1) * ((Y2 - Y1) + 1)) + 4) \ 2

END FUNCTION

SUB Rel.Sprite (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF

BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG


END SUB

SUB Rel.SpriteC (VideoBuf(), X, Y, Sprite(), SpriteOffset, Clr)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking and draws the outline
'of the sprite using Clr. Used for collision detection.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, Clr
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SpriteCT (VideoBuf(), X, Y, Sprite(), SpriteOffset, Clr)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking and draws the outline
'of the sprite using Clr. Translucently.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

TempC = Clr AND 15
BaseColor = Clr - TempC

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                DestCol = PEEK(StartPageOff + Xa) AND 15
                C = ((TempC + DestCol) \ 2) + BaseColor
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

END SUB

SUB Rel.SpriteG (VideoBuf(), X, Y, Sprite(), SpriteOffset, GammaVal)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!
'Gammaval: if <0, draws a darkened sprite. if >0 then lightened. if 0 then normal.


DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF


IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                TempC = C AND 15
                BaseColor = C - TempC
                TempC = (TempC + GammaVal) + BaseColor
                IF TempC < BaseColor THEN
                        TempC = BaseColor
                ELSEIF TempC > BaseColor + 15 THEN
                        TempC = BaseColor + 15
                END IF
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, TempC
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SpriteN (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff(). Solidly.
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Doesn't skip color zero so this is faster
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        DEF SEG = BuffSeg
        POKE StartPageOff + Xa, C
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG



END SUB

SUB Rel.SpriteT (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y. TransLucently!!!!
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))


FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                TempC = C AND 15
                BaseColor = C - TempC
                DEF SEG = BuffSeg
                DestCol = PEEK(StartPageOff + Xa) AND 15
                C = ((TempC + DestCol) \ 2) + BaseColor
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SwitchToPal (PalString$) STATIC
'Switch the current pal to the values held by PalString$
'instantaneously.

TempPal$ = SPACE$(768)
TempPal$ = PalString$
    OUT &H3C8, 0
    FOR I% = 1 TO 768 STEP 3
        OUT &H3C9, ASC(MID$(TempPal$, I%, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 1, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 2, 1))
    NEXT I%

END SUB

SUB Rel.WriteRGB (ColorNum, R, G, B) STATIC
'Writes the R,G and B values to the color Attribute changing its value.

        OUT &H3C8, ColorNum
        OUT &H3C9, R
        OUT &H3C9, G
        OUT &H3C9, B
END SUB

